//---------------------------------------------------------------------------
#ifndef HashCashDlgsH
#define HashCashDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include "explbtn.hpp"
#include <vcl\ExtCtrls.hpp>
#include <vcl\Menus.hpp>
#include <time.h>
#include "global.h"
//---------------------------------------------------------------------------
extern "C" {
long hashcash_valid_for( time_t token_time, time_t validity_period,
			 time_t now_time ); // prototype function in hascash.h but prototype here
}                               // here can't, include hashcash.h

class THashCashDlg : public TForm
{
__published:	// IDE-managed Components
	TPageControl *PageControl;
	TTabSheet *TabMint;
	TTabSheet *TabPool;
	TTabSheet *TabOpts;
	TButton *OkBtn;
	TButton *CloseBtn;
	TEdit *QtyEdit;
	TLabel *Label1;
	TEdit *BitsEdit;
	TLabel *Label2;
	TUpDown *QtyUpDn;
	TUpDown *BitsUpDn;
	TListBox *Pool;
	TCheckBox *TimeBox;
	TComboBox *PriorityBox;
	TLabel *Label4;
	TButton *HelpBtn;
	TLabel *Label5;
	TEdit *Resource;
	TGroupBox *GroupBox1;
	TRadioButton *RememberBtn;
	TRadioButton *CenterBtn;
	TRichEdit *MintDisplay;
	TPanel *Panel1;
	TLabel *Label7;
	TLabel *Label11;
	TLabel *Label12;
	TButton *AboutBtn;
	TLabel *Label8;
	TTimer *Timer1;
	TTimer *Timer2;
	TPanel *TimePanel;
	TOfficeButton *OpenBtn;
	TLabel *Label13;
	TPanel *MintPanel;
	TEdit *AnonTime;
	TLabel *Label15;
	TEdit *ExpireTime;
	TPopupMenu *PopupMenu2;
	TMenuItem *hcwlog1;
	TMenuItem *hcwini1;
	TLabel *Label16;
	TGroupBox *GroupBox2;
	TComboBox *WColorBox;
	TLabel *Label9;
	TLabel *Label10;
	TComboBox *IColorBox;
	TComboBox *TimeWide;
	TLabel *Label6;
	TOfficeButton *SaveBtn;
	TButton *TokensBtn;
	TPopupMenu *PopupMenu3;
	TMenuItem *PopExportItem;
	TMenuItem *PopImportItem;
	TMenuItem *N2;
	TMenuItem *PopDeleteItem;
	void __fastcall TimeBoxClick(TObject *Sender);
	void __fastcall PageControlChange(TObject *Sender);
	void __fastcall OkBtnClick(TObject *Sender);
	void __fastcall RememberBtnClick(TObject *Sender);
	void __fastcall CenterBtnClick(TObject *Sender);
	void __fastcall PoolClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall WColorBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
	   TOwnerDrawState State);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall IColorBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
	   TOwnerDrawState State);
	void __fastcall WColorBoxChange(TObject *Sender);
	void __fastcall IColorBoxChange(TObject *Sender);
	void __fastcall AboutBtnClick(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
	void __fastcall CloseBtnClick(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall Timer2Timer(TObject *Sender);
	void __fastcall PoolDrawItem(TWinControl *Control, int Index, TRect &Rect,
	TOwnerDrawState State);
	void __fastcall hcwlog1Click(TObject *Sender);
	void __fastcall hcwini1Click(TObject *Sender);
	void __fastcall TimeChange(TObject *Sender);
	void __fastcall SaveBtnClick(TObject *Sender);
	void __fastcall PopupMenu3Popup(TObject *Sender);
	void __fastcall PopExportItemClick(TObject *Sender);
	void __fastcall PopImportItemClick(TObject *Sender);
	void __fastcall TokensItemClick(TObject *Sender);
	void __fastcall PoolDblClick(TObject *Sender);
	void __fastcall PopDeleteItemClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    int minted,ms,ss,hs,holdpriority;
    AnsiString holdqty,holdtokens,holdbits,holdresource;
    BOOL centered,cancel,modified;
    //TStringList *orgpool;
    // items used by commandline switches
    AnsiString clResource,cap,clPriority,Xhashcash;
    int clTokens,clBits;
    bool clMint,clSpend,clMinimized,clSetup,attended;
	__fastcall THashCashDlg(TComponent* Owner);
    __fastcall virtual ~THashCashDlg();
    void __fastcall DisplayLast(AnsiString line);
    void __fastcall Display(AnsiString line);
    TThreadPriority __fastcall Priority();
    void __fastcall WaitWhileTokenFileLocked();
    BOOL __fastcall GetIniSection(AnsiString name, TStrings *section, TStrings *ini);
    void __fastcall SaveTokenPool(TStrings *tokens);
    void __fastcall LoadTokenPool(TStrings *tokens);
    void __fastcall EnableInputs(bool Enable);
    bool __fastcall ExpiredToken(AnsiString token);
    void __fastcall CheckDeleteExpireds();
    bool __fastcall WriteDesktopShortcuts();
    AnsiString __fastcall ValidityPeriod();
    AnsiString __fastcall AnonPeriod();
    int  __fastcall ValidTimeInSeconds();
    int  __fastcall ValidField(int atpos);
    int  __fastcall AnonTimeInSeconds();
    int  __fastcall AnonField(int atpos);
    void __fastcall ShowValidRandAvailValues();
    int  __fastcall TokenStatus(AnsiString token);
    bool __fastcall TokenValidInFuture(AnsiString token);
    bool __fastcall ValidHashCash(AnsiString &token, AnsiString &errormsg);
    bool __fastcall ValidResource();
    bool __fastcall ValidTokens();
    bool __fastcall ValidValidity();
    bool __fastcall ValidRandom();
    bool __fastcall ValidBits();
    bool __fastcall ValidInput();
    void virtual __fastcall WMSpendToken(TMessage& Msg);
    // message map
    BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(WM_SPENDTOKEN,TMessage,WMSpendToken)
    END_MESSAGE_MAP(TForm)
};

#define MAX_UTC 13
#define MAX_CTR 64
#define MAX_RES 256
#define MAX_STR 256
#define MAX_TOK ((MAX_RES)+1+(MAX_UTC)+1+(MAX_STR))

#define TIME_MINUTE 60
#define TIME_HOUR (TIME_MINUTE*60)
#define TIME_DAY (TIME_HOUR*24)
#define TIME_YEAR (TIME_DAY*365)
#define TIME_MONTH (TIME_YEAR/12)
#define TIME_AEON (TIME_YEAR*1000000000.0)
#define TIME_MILLI_SECOND (1.0/1000)
#define TIME_MICRO_SECOND (TIME_MILLI_SECOND/1000)
#define TIME_NANO_SECOND (TIME_MICRO_SECOND/1000)

#define HASHCASH_OK 1
#define HASHCASH_FAIL 0
#define HASHCASH_VALID_FOREVER 0
#define HASHCASH_INVALID_TOK_LEN -1
#define HASHCASH_RNG_FAILED -2
#define HASHCASH_INVALID_TIME -3
#define HASHCASH_TOO_MANY_TRIES -4
#define HASHCASH_EXPIRED_ON_CREATION -5
#define HASHCASH_INVALID_VALIDITY_PERIOD -6
#define HASHCASH_NULL_ARG -7
#define HASHCASH_INVALID_TIME_WIDTH -8
#define HASHCASH_VALID_IN_FUTURE -9
#define HASHCASH_EXPIRED -10
#define HASHCASH_INVALID -11
#define HASHCASH_WRONG_RESOURCE -12
#define HASHCASH_INSUFFICIENT_BITS -13

#define HASHCASH_USERCANCEL -128

#define HASHCASH_VALID_TOKEN 1

AnsiString __fastcall Seconds2HMS(double seconds);
AnsiString __fastcall Seconds2DHMS(long seconds);
AnsiString __fastcall GetTokenOrZero(int pos, AnsiString fromstring, AnsiString divider);
AnsiString __fastcall TimeTo2Digits(TEdit *value); // takes "0" returns "00"
extern "C" {
int hashcash_parse( const char* token, char* utct, int utct_max,
		    char* token_resource, int res_max );
}
//---------------------------------------------------------------------------
extern THashCashDlg *HashCashDlg;
extern HWND hWndHCW;
//---------------------------------------------------------------------------
#endif
