//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\inifiles.hpp>
#pragma hdrstop

#include "HelpDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
THelpDlg *HelpDlg;
const int quick=1;
const int mint=2;
const int queue=3;
const int opts=4;
const int swtch=5;
const AnsiString helpwinpos = "helpwinpos";
//---------------------------------------------------------------------------
void __fastcall OpenHelp(TForm *Owner, int ActivePage, bool Centered)
{
   HelpDlg = new THelpDlg(Owner);
   if (!Centered)
   {
      HelpDlg->Position = poDesigned;
      TIniFile *ini = new TIniFile(AppIni);
      AnsiString winpos = ini->ReadString("main",helpwinpos,"1,1,400,300");
      delete ini;
      for (int i=0; i<4; i++)
      {
         int val = GetToken(i,winpos,",").ToIntDef(-1);
         if (val>=0)
         {
            switch (i)
            {
               case 0: HelpDlg->Left = val; break;
               case 1: HelpDlg->Top = val; break;
               case 2: HelpDlg->Width = val; break;
               case 3: HelpDlg->Height = val; break;
            }
         }
      }
   }
   AnsiString helpfile = AppHelp;
   TStringList *help = new TStringList();
   HelpDlg->PageControl1->ActivePage = HelpDlg->GetFrontPage(ActivePage);
   if (!FileExists(helpfile)) helpfile = AppDir+"hcw\\hcw.txt";
   if ( FileExists(helpfile)) help->LoadFromFile(helpfile);
   else
   {
      BingBox(Owner,
         "The application help file (HCW.txt) is missing!",
         "Help Error",MB_OK);
      return;
   }
   int p,page=0;
   for (int i=0; i<help->Count; i++)
   {
      p=page;
      AnsiString line = help->Strings[i];
      if (line.Pos("QuickStart:--------------------")==1) page = 5; else
      if (line.Pos("Mint:--------------------------")==1) page = 1; else
      if (line.Pos("Queue:-------------------------")==1) page = 2; else
      if (line.Pos("Options:-----------------------")==1) page = 3; else
      if (line.Pos("Switches:----------------------")==1) page = 4;
      if (page!=p) continue;

      switch(page)
      {
         case quick: HelpDlg->Memo1->Lines->Add(line); break;
         case mint : HelpDlg->Memo2->Lines->Add(line); break;
         case queue: HelpDlg->Memo3->Lines->Add(line); break;
         case opts : HelpDlg->Memo4->Lines->Add(line); break;
         case swtch: HelpDlg->Memo5->Lines->Add(line); break;
      }
   }
   delete help;
   HelpDlg->Show();
}
//---------------------------------------------------------------------------
__fastcall THelpDlg::THelpDlg(TComponent* Owner)
	: TForm(Owner)
{
   PageControl1->ActivePage = TabSheet5;
   CenterDialog(this,Owner);
}
//---------------------------------------------------------------------------
TTabSheet* __fastcall THelpDlg::GetFrontPage(int page)
{
   switch(page)
   {
      case 0: return TabSheet5;
      case 1: return TabSheet1;
      case 2: return TabSheet2;
      case 3: return TabSheet3;
      case 4: return TabSheet4;
   }
   return 0;
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
   TIniFile *ini = new TIniFile(AppIni);
   ini->WriteString("main",helpwinpos,s(Left)+","+s(Top)+","+s(Width)+","+s(Height));
   Action = caFree;
   delete ini;
}
//---------------------------------------------------------------------------